/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import OrderTypeValues from './OrderTypeValues';

/**
 * The OrderTypes model module.
 * @module model/OrderTypes
 * @version 2021.12-dev21
 */
class OrderTypes {
    /**
     * Constructs a new <code>OrderTypes</code>.
     * @alias module:model/OrderTypes
     * @param buy {module:model/OrderTypeValues} 
     * @param sell {module:model/OrderTypeValues} 
     * @param stoploss {module:model/OrderTypeValues} 
     * @param stoplossOnExchange {Boolean} 
     */
    constructor(buy, sell, stoploss, stoplossOnExchange) { 
        
        OrderTypes.initialize(this, buy, sell, stoploss, stoplossOnExchange);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, buy, sell, stoploss, stoplossOnExchange) { 
        obj['buy'] = buy;
        obj['sell'] = sell;
        obj['stoploss'] = stoploss;
        obj['stoploss_on_exchange'] = stoplossOnExchange;
    }

    /**
     * Constructs a <code>OrderTypes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/OrderTypes} obj Optional instance to populate.
     * @return {module:model/OrderTypes} The populated <code>OrderTypes</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new OrderTypes();

            if (data.hasOwnProperty('buy')) {
                obj['buy'] = OrderTypeValues.constructFromObject(data['buy']);
            }
            if (data.hasOwnProperty('sell')) {
                obj['sell'] = OrderTypeValues.constructFromObject(data['sell']);
            }
            if (data.hasOwnProperty('emergencysell')) {
                obj['emergencysell'] = OrderTypeValues.constructFromObject(data['emergencysell']);
            }
            if (data.hasOwnProperty('forcesell')) {
                obj['forcesell'] = OrderTypeValues.constructFromObject(data['forcesell']);
            }
            if (data.hasOwnProperty('forcebuy')) {
                obj['forcebuy'] = OrderTypeValues.constructFromObject(data['forcebuy']);
            }
            if (data.hasOwnProperty('stoploss')) {
                obj['stoploss'] = OrderTypeValues.constructFromObject(data['stoploss']);
            }
            if (data.hasOwnProperty('stoploss_on_exchange')) {
                obj['stoploss_on_exchange'] = ApiClient.convertToType(data['stoploss_on_exchange'], 'Boolean');
            }
            if (data.hasOwnProperty('stoploss_on_exchange_interval')) {
                obj['stoploss_on_exchange_interval'] = ApiClient.convertToType(data['stoploss_on_exchange_interval'], 'Number');
            }
        }
        return obj;
    }


}

/**
 * @member {module:model/OrderTypeValues} buy
 */
OrderTypes.prototype['buy'] = undefined;

/**
 * @member {module:model/OrderTypeValues} sell
 */
OrderTypes.prototype['sell'] = undefined;

/**
 * @member {module:model/OrderTypeValues} emergencysell
 */
OrderTypes.prototype['emergencysell'] = undefined;

/**
 * @member {module:model/OrderTypeValues} forcesell
 */
OrderTypes.prototype['forcesell'] = undefined;

/**
 * @member {module:model/OrderTypeValues} forcebuy
 */
OrderTypes.prototype['forcebuy'] = undefined;

/**
 * @member {module:model/OrderTypeValues} stoploss
 */
OrderTypes.prototype['stoploss'] = undefined;

/**
 * @member {Boolean} stoploss_on_exchange
 */
OrderTypes.prototype['stoploss_on_exchange'] = undefined;

/**
 * @member {Number} stoploss_on_exchange_interval
 */
OrderTypes.prototype['stoploss_on_exchange_interval'] = undefined;






export default OrderTypes;

